/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-07 16:52
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

const int MAXN = 2e5 + 5;
ll N;

void solve(){
    // Code goes here ...
    cin >> N;
    
    ll lenb = (N * (N-1)) / 2, t;
    set<ll> values;
    multiset<ll> mvalues;

    R(i, lenb){
        cin >> t;
        values.emplace(t);
        mvalues.emplace(t);
    }
    ll amount = N-1;
    for(auto ele: values){
        ll multiplicity = mvalues.count(ele);
        while(multiplicity > amount){
            cout << ele << " ";
            multiplicity -= amount;
            amount--;
        }
        if (multiplicity != amount){
            cerr << "BIG Error" << endl;
        }
        cout << ele << " ";
        amount--;
        /* cout << mvalues.count(ele) << " "; */
    }
    cout << *max_element(values.begin(), values.end()) << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(8);
    int T;
    cin >> T;
    while(T--)
        solve();
}
        
